Index: dll/shellext/shellbtrfs/propsheet.cpp
===================================================================
--- dll/shellext/shellbtrfs/propsheet.cpp	(révision 75772)
+++ dll/shellext/shellbtrfs/propsheet.cpp	(copie de travail)
@@ -561,17 +719,17 @@
         case WM_INITDIALOG:
         {
             BtrfsPropSheet* bps = (BtrfsPropSheet*)lParam;
-            
+
             SetWindowLongPtr(hwndDlg, GWLP_USERDATA, (LONG_PTR)bps);
-            
+
             bps->update_size_details_dialog(hwndDlg);
-            
+
             if (bps->thread)
                 SetTimer(hwndDlg, 1, 250, NULL);
-            
+
             return TRUE;
         }
-            
+
         case WM_COMMAND:
             if (HIWORD(wParam) == BN_CLICKED && (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)) {
                 EndDialog(hwndDlg, 0);
@@ -578,22 +736,22 @@
                 return TRUE;
             }
         break;
-        
+
         case WM_TIMER:
         {
             BtrfsPropSheet* bps = (BtrfsPropSheet*)GetWindowLongPtr(hwndDlg, GWLP_USERDATA);
-            
+
             if (bps) {
                 bps->update_size_details_dialog(hwndDlg);
-                
+
                 if (!bps->thread)
                     KillTimer(hwndDlg, 1);
             }
-            
+
             break;
         }
     }
-    
+
     return FALSE;
 }
 
@@ -604,16 +762,240 @@
         SendDlgItemMessage(hwndDlg, id, BM_SETCHECK, BST_UNCHECKED, 0);
     } else {
         LONG_PTR style;
-        
+
         style = GetWindowLongPtr(GetDlgItem(hwndDlg, id), GWL_STYLE);
         style &= ~BS_AUTOCHECKBOX;
         style |= BS_AUTO3STATE;
         SetWindowLongPtr(GetDlgItem(hwndDlg, id), GWL_STYLE, style);
-        
+
         SendDlgItemMessage(hwndDlg, id, BM_SETCHECK, BST_INDETERMINATE, 0);
     }
 }
 
+void BtrfsPropSheet::open_as_admin(HWND hwndDlg) {
+    ULONG num_files, i;
+    WCHAR fn[MAX_PATH];
+
+    num_files = DragQueryFileW((HDROP)stgm.hGlobal, 0xFFFFFFFF, NULL, 0);
+
+    for (i = 0; i < num_files; i++) {
+        if (DragQueryFileW((HDROP)stgm.hGlobal, i, fn, sizeof(fn) / sizeof(MAX_PATH))) {
+            WCHAR t[MAX_PATH + 100];
+            SHELLEXECUTEINFOW sei;
+
+            t[0] = '"';
+            GetModuleFileNameW(module, t + 1, (sizeof(t) / sizeof(WCHAR)) - 1);
+            wcscat(t, L"\",ShowPropSheet ");
+            wcscat(t, fn);
+
+            RtlZeroMemory(&sei, sizeof(sei));
+
+            sei.cbSize = sizeof(sei);
+            sei.hwnd = hwndDlg;
+            sei.lpVerb = L"runas";
+            sei.lpFile = L"rundll32.exe";
+            sei.lpParameters = t;
+            sei.nShow = SW_SHOW;
+            sei.fMask = SEE_MASK_NOCLOSEPROCESS;
+
+            if (!ShellExecuteExW(&sei)) {
+                ShowError(hwndDlg, GetLastError());
+                return;
+            }
+
+            WaitForSingleObject(sei.hProcess, INFINITE);
+            CloseHandle(sei.hProcess);
+
+            load_file_list();
+            init_propsheet(hwndDlg);
+        }
+    }
+}
+
+// based on functions in sys/sysmacros.h
+#define major(rdev) ((((rdev) >> 8) & 0xFFF) | ((UINT32)((rdev) >> 32) & ~0xFFF))
+#define minor(rdev) (((rdev) & 0xFF) | ((UINT32)((rdev) >> 12) & ~0xFF))
+
+void BtrfsPropSheet::init_propsheet(HWND hwndDlg) {
+    WCHAR s[255];
+    ULONG sr;
+    int i;
+    HWND comptype;
+
+    static ULONG perm_controls[] = { IDC_USERR, IDC_USERW, IDC_USERX, IDC_GROUPR, IDC_GROUPW, IDC_GROUPX, IDC_OTHERR, IDC_OTHERW, IDC_OTHERX,
+                                     IDC_SETUID, IDC_SETGID, IDC_STICKY, 0 };
+    static ULONG perms[] = { S_IRUSR, S_IWUSR, S_IXUSR, S_IRGRP, S_IWGRP, S_IXGRP, S_IROTH, S_IWOTH, S_IXOTH, S_ISUID, S_ISGID, S_ISVTX, 0 };
+    static ULONG comp_types[] = { IDS_COMPRESS_ANY, IDS_COMPRESS_ZLIB, IDS_COMPRESS_LZO, 0 };
+
+    if (various_subvols) {
+        if (!LoadStringW(module, IDS_VARIOUS, s, sizeof(s) / sizeof(WCHAR))) {
+            ShowError(hwndDlg, GetLastError());
+            return;
+        }
+    } else {
+        if (StringCchPrintfW(s, sizeof(s) / sizeof(WCHAR), L"%llx", subvol) == STRSAFE_E_INSUFFICIENT_BUFFER)
+            return;
+    }
+
+    SetDlgItemTextW(hwndDlg, IDC_SUBVOL, s);
+
+    if (various_inodes) {
+        if (!LoadStringW(module, IDS_VARIOUS, s, sizeof(s) / sizeof(WCHAR))) {
+            ShowError(hwndDlg, GetLastError());
+            return;
+        }
+    } else {
+        if (StringCchPrintfW(s, sizeof(s) / sizeof(WCHAR), L"%llx", inode) == STRSAFE_E_INSUFFICIENT_BUFFER)
+            return;
+    }
+
+    SetDlgItemTextW(hwndDlg, IDC_INODE, s);
+
+    if (various_types)
+        sr = IDS_VARIOUS;
+    else
+        sr = inode_type_to_string_ref(type);
+
+    if (various_inodes) {
+        if (sr == IDS_INODE_CHAR)
+            sr = IDS_INODE_CHAR_SIMPLE;
+        else if (sr == IDS_INODE_BLOCK)
+            sr = IDS_INODE_BLOCK_SIMPLE;
+    }
+
+    if (sr == IDS_INODE_UNKNOWN) {
+        WCHAR t[255];
+
+        if (!LoadStringW(module, sr, t, sizeof(t) / sizeof(WCHAR))) {
+            ShowError(hwndDlg, GetLastError());
+            return;
+        }
+
+        if (StringCchPrintfW(s, sizeof(s) / sizeof(WCHAR), t, type) == STRSAFE_E_INSUFFICIENT_BUFFER)
+            return;
+    } else if (sr == IDS_INODE_CHAR || sr == IDS_INODE_BLOCK) {
+        WCHAR t[255];
+
+        if (!LoadStringW(module, sr, t, sizeof(t) / sizeof(WCHAR))) {
+            ShowError(hwndDlg, GetLastError());
+            return;
+        }
+
+        if (StringCchPrintfW(s, sizeof(s) / sizeof(WCHAR), t, major(rdev), minor(rdev)) == STRSAFE_E_INSUFFICIENT_BUFFER)
+            return;
+    } else {
+        if (!LoadStringW(module, sr, s, sizeof(s) / sizeof(WCHAR))) {
+            ShowError(hwndDlg, GetLastError());
+            return;
+        }
+    }
+
+    SetDlgItemTextW(hwndDlg, IDC_TYPE, s);
+
+    GetDlgItemTextW(hwndDlg, IDC_SIZE_ON_DISK, size_format, sizeof(size_format) / sizeof(WCHAR));
+    set_size_on_disk(hwndDlg);
+
+    if (thread)
+        SetTimer(hwndDlg, 1, 250, NULL);
+
+    set_check_box(hwndDlg, IDC_NODATACOW, min_flags & BTRFS_INODE_NODATACOW, max_flags & BTRFS_INODE_NODATACOW);
+    set_check_box(hwndDlg, IDC_COMPRESS, min_flags & BTRFS_INODE_COMPRESS, max_flags & BTRFS_INODE_COMPRESS);
+
+    comptype = GetDlgItem(hwndDlg, IDC_COMPRESS_TYPE);
+
+    if (min_compression_type != max_compression_type) {
+        SendMessage(comptype, CB_ADDSTRING, NULL, (LPARAM)L"");
+        SendMessage(comptype, CB_SETCURSEL, 0, 0);
+    }
+
+    i = 0;
+    while (comp_types[i] != 0) {
+        WCHAR t[255];
+
+        if (!LoadStringW(module, comp_types[i], t, sizeof(t) / sizeof(WCHAR))) {
+            ShowError(hwndDlg, GetLastError());
+            return;
+        }
+
+        SendMessage(comptype, CB_ADDSTRING, NULL, (LPARAM)t);
+
+        i++;
+    }
+
+    if (min_compression_type == max_compression_type) {
+        SendMessage(comptype, CB_SETCURSEL, min_compression_type, 0);
+        compress_type = min_compression_type;
+    }
+
+    EnableWindow(comptype, max_flags & BTRFS_INODE_COMPRESS);
+
+    i = 0;
+    while (perm_controls[i] != 0) {
+        set_check_box(hwndDlg, perm_controls[i], min_mode & perms[i], max_mode & perms[i]);
+        i++;
+    }
+
+    if (various_uids) {
+        if (!LoadStringW(module, IDS_VARIOUS, s, sizeof(s) / sizeof(WCHAR))) {
+            ShowError(hwndDlg, GetLastError());
+            return;
+        }
+
+        EnableWindow(GetDlgItem(hwndDlg, IDC_UID), 0);
+    } else {
+        if (StringCchPrintfW(s, sizeof(s) / sizeof(WCHAR), L"%u", uid) == STRSAFE_E_INSUFFICIENT_BUFFER)
+            return;
+    }
+
+    SetDlgItemTextW(hwndDlg, IDC_UID, s);
+
+    if (various_gids) {
+        if (!LoadStringW(module, IDS_VARIOUS, s, sizeof(s) / sizeof(WCHAR))) {
+            ShowError(hwndDlg, GetLastError());
+            return;
+        }
+
+        EnableWindow(GetDlgItem(hwndDlg, IDC_GID), 0);
+    } else {
+        if (StringCchPrintfW(s, sizeof(s) / sizeof(WCHAR), L"%u", gid) == STRSAFE_E_INSUFFICIENT_BUFFER)
+            return;
+    }
+
+    SetDlgItemTextW(hwndDlg, IDC_GID, s);
+
+    ShowWindow(GetDlgItem(hwndDlg, IDC_SUBVOL_RO), has_subvols);
+
+    if (has_subvols)
+        set_check_box(hwndDlg, IDC_SUBVOL_RO, ro_subvol, various_ro ? (!ro_subvol) : ro_subvol);
+
+    if (!can_change_nocow)
+        EnableWindow(GetDlgItem(hwndDlg, IDC_NODATACOW), 0);
+
+    if (!can_change_perms) {
+        i = 0;
+        while (perm_controls[i] != 0) {
+            EnableWindow(GetDlgItem(hwndDlg, perm_controls[i]), 0);
+            i++;
+        }
+
+        EnableWindow(GetDlgItem(hwndDlg, IDC_UID), 0);
+        EnableWindow(GetDlgItem(hwndDlg, IDC_GID), 0);
+        EnableWindow(GetDlgItem(hwndDlg, IDC_SETUID), 0);
+    }
+
+    if (readonly) {
+        EnableWindow(GetDlgItem(hwndDlg, IDC_NODATACOW), 0);
+        EnableWindow(GetDlgItem(hwndDlg, IDC_COMPRESS), 0);
+        EnableWindow(GetDlgItem(hwndDlg, IDC_COMPRESS_TYPE), 0);
+    }
+
+    if (show_admin_button) {
+        SendMessageW(GetDlgItem(hwndDlg, IDC_OPEN_ADMIN), BCM_SETSHIELD, 0, TRUE);
+        ShowWindow(GetDlgItem(hwndDlg, IDC_OPEN_ADMIN), SW_SHOW);
+    } else
+        ShowWindow(GetDlgItem(hwndDlg, IDC_OPEN_ADMIN), SW_HIDE);
+}
+
 static INT_PTR CALLBACK PropSheetDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
     switch (uMsg) {
         case WM_INITDIALOG:
@@ -620,234 +1002,165 @@
         {
             PROPSHEETPAGE* psp = (PROPSHEETPAGE*)lParam;
             BtrfsPropSheet* bps = (BtrfsPropSheet*)psp->lParam;
-            WCHAR s[255];
-            ULONG sr;
-            int i;
-            
-            static ULONG perm_controls[] = { IDC_USERR, IDC_USERW, IDC_USERX, IDC_GROUPR, IDC_GROUPW, IDC_GROUPX, IDC_OTHERR, IDC_OTHERW, IDC_OTHERX, 0 };
-            static ULONG perms[] = { S_IRUSR, S_IWUSR, S_IXUSR, S_IRGRP, S_IWGRP, S_IXGRP, S_IROTH, S_IWOTH, S_IXOTH, 0 };
-            
+
             EnableThemeDialogTexture(hwndDlg, ETDT_ENABLETAB);
-            
+
             SetWindowLongPtr(hwndDlg, GWLP_USERDATA, (LONG_PTR)bps);
-            
-            if (bps->various_subvols) {
-                if (!LoadStringW(module, IDS_VARIOUS, s, sizeof(s) / sizeof(WCHAR))) {
-                    ShowError(hwndDlg, GetLastError());
-                    return FALSE;
-                }
-            } else {
-                if (StringCchPrintfW(s, sizeof(s) / sizeof(WCHAR), L"%llx", bps->subvol) == STRSAFE_E_INSUFFICIENT_BUFFER)
-                    return FALSE;
-            }
-            
-            SetDlgItemTextW(hwndDlg, IDC_SUBVOL, s);
-            
-            if (bps->various_inodes) {
-                if (!LoadStringW(module, IDS_VARIOUS, s, sizeof(s) / sizeof(WCHAR))) {
-                    ShowError(hwndDlg, GetLastError());
-                    return FALSE;
-                }
-            } else {
-                if (StringCchPrintfW(s, sizeof(s) / sizeof(WCHAR), L"%llx", bps->inode) == STRSAFE_E_INSUFFICIENT_BUFFER)
-                    return FALSE;
-            }
-            
-            SetDlgItemTextW(hwndDlg, IDC_INODE, s);
-            
-            if (bps->various_types)
-                sr = IDS_VARIOUS;
-            else
-                sr = inode_type_to_string_ref(bps->type);
-            
-            if (bps->various_inodes) {
-                if (sr == IDS_INODE_CHAR)
-                    sr = IDS_INODE_CHAR_SIMPLE;
-                else if (sr == IDS_INODE_BLOCK)
-                    sr = IDS_INODE_BLOCK_SIMPLE;
-            }
-            
-            if (sr == IDS_INODE_UNKNOWN) {
-                WCHAR t[255];
-                
-                if (!LoadStringW(module, sr, t, sizeof(t) / sizeof(WCHAR))) {
-                    ShowError(hwndDlg, GetLastError());
-                    return FALSE;
-                }
-                
-                if (StringCchPrintfW(s, sizeof(s) / sizeof(WCHAR), t, bps->type) == STRSAFE_E_INSUFFICIENT_BUFFER)
-                    return FALSE;
-            } else if (sr == IDS_INODE_CHAR || sr == IDS_INODE_BLOCK) {
-                WCHAR t[255];
-                
-                if (!LoadStringW(module, sr, t, sizeof(t) / sizeof(WCHAR))) {
-                    ShowError(hwndDlg, GetLastError());
-                    return FALSE;
-                }
-                
-                if (StringCchPrintfW(s, sizeof(s) / sizeof(WCHAR), t, (UINT64)((bps->rdev & 0xFFFFFFFFFFF) >> 20), (UINT32)(bps->rdev & 0xFFFFF)) == STRSAFE_E_INSUFFICIENT_BUFFER)
-                    return FALSE;
-            } else {
-                if (!LoadStringW(module, sr, s, sizeof(s) / sizeof(WCHAR))) {
-                    ShowError(hwndDlg, GetLastError());
-                    return FALSE;
-                }
-            }
-            
-            SetDlgItemTextW(hwndDlg, IDC_TYPE, s);
-            
-            GetDlgItemTextW(hwndDlg, IDC_SIZE_ON_DISK, bps->size_format, sizeof(bps->size_format) / sizeof(WCHAR));
-            bps->set_size_on_disk(hwndDlg);
-            
-            if (bps->thread)
-                SetTimer(hwndDlg, 1, 250, NULL);
-            
-            set_check_box(hwndDlg, IDC_NODATACOW, bps->min_flags & BTRFS_INODE_NODATACOW, bps->max_flags & BTRFS_INODE_NODATACOW);
-            set_check_box(hwndDlg, IDC_COMPRESS, bps->min_flags & BTRFS_INODE_COMPRESS, bps->max_flags & BTRFS_INODE_COMPRESS);
-            
-            i = 0;
-            while (perm_controls[i] != 0) {
-                set_check_box(hwndDlg, perm_controls[i], bps->min_mode & perms[i], bps->max_mode & perms[i]);
-                i++;
-            }
-            
-            if (bps->various_uids) {
-                if (!LoadStringW(module, IDS_VARIOUS, s, sizeof(s) / sizeof(WCHAR))) {
-                    ShowError(hwndDlg, GetLastError());
-                    return FALSE;
-                }
-                
-                EnableWindow(GetDlgItem(hwndDlg, IDC_UID), 0);
-            } else {
-                if (StringCchPrintfW(s, sizeof(s) / sizeof(WCHAR), L"%u", bps->uid) == STRSAFE_E_INSUFFICIENT_BUFFER)
-                    return FALSE;
-            }
-            
-            SetDlgItemTextW(hwndDlg, IDC_UID, s);
-            
-            if (bps->various_gids) {
-                if (!LoadStringW(module, IDS_VARIOUS, s, sizeof(s) / sizeof(WCHAR))) {
-                    ShowError(hwndDlg, GetLastError());
-                    return FALSE;
-                }
-                
-                EnableWindow(GetDlgItem(hwndDlg, IDC_GID), 0);
-            } else {
-                if (StringCchPrintfW(s, sizeof(s) / sizeof(WCHAR), L"%u", bps->gid) == STRSAFE_E_INSUFFICIENT_BUFFER)
-                    return FALSE;
-            }
-            
-            SetDlgItemTextW(hwndDlg, IDC_GID, s);
-            
-            if (!bps->can_change_nocow)
-                EnableWindow(GetDlgItem(hwndDlg, IDC_NODATACOW), 0);
-            
-            if (!bps->can_change_owner) {
-                EnableWindow(GetDlgItem(hwndDlg, IDC_UID), 0);
-                EnableWindow(GetDlgItem(hwndDlg, IDC_GID), 0);
-            }
-            
-            if (!bps->can_change_perms) {
-                EnableWindow(GetDlgItem(hwndDlg, IDC_USERR), 0);
-                EnableWindow(GetDlgItem(hwndDlg, IDC_USERW), 0);
-                EnableWindow(GetDlgItem(hwndDlg, IDC_USERX), 0);
-                EnableWindow(GetDlgItem(hwndDlg, IDC_GROUPR), 0);
-                EnableWindow(GetDlgItem(hwndDlg, IDC_GROUPW), 0);
-                EnableWindow(GetDlgItem(hwndDlg, IDC_GROUPX), 0);
-                EnableWindow(GetDlgItem(hwndDlg, IDC_OTHERR), 0);
-                EnableWindow(GetDlgItem(hwndDlg, IDC_OTHERW), 0);
-                EnableWindow(GetDlgItem(hwndDlg, IDC_OTHERX), 0);
-            }
-            
-            if (bps->readonly) {
-                EnableWindow(GetDlgItem(hwndDlg, IDC_NODATACOW), 0);
-                EnableWindow(GetDlgItem(hwndDlg, IDC_COMPRESS), 0);
-            }
-            
+
+            bps->init_propsheet(hwndDlg);
+
             return FALSE;
         }
-        
+
         case WM_COMMAND:
         {
             BtrfsPropSheet* bps = (BtrfsPropSheet*)GetWindowLongPtr(hwndDlg, GWLP_USERDATA);
-            
+
             if (bps && !bps->readonly) {
                 switch (HIWORD(wParam)) {
                     case BN_CLICKED: {
                         switch (LOWORD(wParam)) {
                             case IDC_NODATACOW:
-                                bps->change_inode_flag(hwndDlg, BTRFS_INODE_NODATACOW, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)) == BST_CHECKED);
+                                bps->change_inode_flag(hwndDlg, BTRFS_INODE_NODATACOW, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)));
                             break;
-                            
+
                             case IDC_COMPRESS:
-                                bps->change_inode_flag(hwndDlg, BTRFS_INODE_COMPRESS, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)) == BST_CHECKED);
+                                bps->change_inode_flag(hwndDlg, BTRFS_INODE_COMPRESS, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)));
+
+                                EnableWindow(GetDlgItem(hwndDlg, IDC_COMPRESS_TYPE), IsDlgButtonChecked(hwndDlg, LOWORD(wParam)) != BST_UNCHECKED);
                             break;
-                            
+
                             case IDC_USERR:
-                                bps->change_perm_flag(hwndDlg, S_IRUSR, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)) == BST_CHECKED);
+                                bps->change_perm_flag(hwndDlg, S_IRUSR, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)));
                             break;
-                            
+
                             case IDC_USERW:
-                                bps->change_perm_flag(hwndDlg, S_IWUSR, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)) == BST_CHECKED);
+                                bps->change_perm_flag(hwndDlg, S_IWUSR, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)));
                             break;
-                            
+
                             case IDC_USERX:
-                                bps->change_perm_flag(hwndDlg, S_IXUSR, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)) == BST_CHECKED);
+                                bps->change_perm_flag(hwndDlg, S_IXUSR, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)));
                             break;
-                            
+
                             case IDC_GROUPR:
-                                bps->change_perm_flag(hwndDlg, S_IRGRP, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)) == BST_CHECKED);
+                                bps->change_perm_flag(hwndDlg, S_IRGRP, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)));
                             break;
-                            
+
                             case IDC_GROUPW:
-                                bps->change_perm_flag(hwndDlg, S_IWGRP, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)) == BST_CHECKED);
+                                bps->change_perm_flag(hwndDlg, S_IWGRP, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)));
                             break;
-                            
+
                             case IDC_GROUPX:
-                                bps->change_perm_flag(hwndDlg, S_IXGRP, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)) == BST_CHECKED);
+                                bps->change_perm_flag(hwndDlg, S_IXGRP, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)));
                             break;
-                            
+
                             case IDC_OTHERR:
-                                bps->change_perm_flag(hwndDlg, S_IROTH, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)) == BST_CHECKED);
+                                bps->change_perm_flag(hwndDlg, S_IROTH, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)));
                             break;
-                            
+
                             case IDC_OTHERW:
-                                bps->change_perm_flag(hwndDlg, S_IWOTH, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)) == BST_CHECKED);
+                                bps->change_perm_flag(hwndDlg, S_IWOTH, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)));
                             break;
-                            
+
                             case IDC_OTHERX:
-                                bps->change_perm_flag(hwndDlg, S_IXOTH, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)) == BST_CHECKED);
+                                bps->change_perm_flag(hwndDlg, S_IXOTH, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)));
                             break;
+
+                            case IDC_SETUID:
+                                bps->change_perm_flag(hwndDlg, S_ISUID, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)));
+                            break;
+
+                            case IDC_SETGID:
+                                bps->change_perm_flag(hwndDlg, S_ISGID, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)));
+                            break;
+
+                            case IDC_STICKY:
+                                bps->change_perm_flag(hwndDlg, S_ISVTX, IsDlgButtonChecked(hwndDlg, LOWORD(wParam)));
+                            break;
+
+                            case IDC_SUBVOL_RO:
+                                switch (IsDlgButtonChecked(hwndDlg, LOWORD(wParam))) {
+                                    case BST_CHECKED:
+                                        bps->ro_subvol = TRUE;
+                                        bps->ro_changed = TRUE;
+                                    break;
+
+                                    case BST_UNCHECKED:
+                                        bps->ro_subvol = FALSE;
+                                        bps->ro_changed = TRUE;
+                                    break;
+
+                                    case BST_INDETERMINATE:
+                                        bps->ro_changed = FALSE;
+                                    break;
+                                }
+
+                                SendMessageW(GetParent(hwndDlg), PSM_CHANGED, (WPARAM)hwndDlg, 0);
+                            break;
+
+                            case IDC_OPEN_ADMIN:
+                                bps->open_as_admin(hwndDlg);
+                            break;
                         }
+
+                        break;
                     }
-                    
+
                     case EN_CHANGE: {
                         switch (LOWORD(wParam)) {
                             case IDC_UID: {
                                 WCHAR s[255];
-                                
+
                                 GetDlgItemTextW(hwndDlg, LOWORD(wParam), s, sizeof(s) / sizeof(WCHAR));
-                                
+
                                 bps->change_uid(hwndDlg, _wtoi(s));
                                 break;
                             }
-                            
+
                             case IDC_GID: {
                                 WCHAR s[255];
-                                
+
                                 GetDlgItemTextW(hwndDlg, LOWORD(wParam), s, sizeof(s) / sizeof(WCHAR));
-                                
+
                                 bps->change_gid(hwndDlg, _wtoi(s));
                                 break;
                             }
                         }
+
+                        break;
                     }
+
+                    case CBN_SELCHANGE: {
+                        switch (LOWORD(wParam)) {
+                            case IDC_COMPRESS_TYPE: {
+                                int sel = SendMessageW(GetDlgItem(hwndDlg, LOWORD(wParam)), CB_GETCURSEL, 0, 0);
+
+                                if (bps->min_compression_type != bps->max_compression_type) {
+                                    if (sel == 0)
+                                        bps->compress_type_changed = FALSE;
+                                    else {
+                                        bps->compress_type = sel - 1;
+                                        bps->compress_type_changed = TRUE;
+                                    }
+                                } else {
+                                    bps->compress_type = sel;
+                                    bps->compress_type_changed = TRUE;
+                                }
+
+                                SendMessageW(GetParent(hwndDlg), PSM_CHANGED, (WPARAM)hwndDlg, 0);
+
+                                break;
+                            }
+                        }
+
+                        break;
+                    }
                 }
             }
-            
+
             break;
         }
-        
+
         case WM_NOTIFY:
         {
             switch (((LPNMHDR)lParam)->code) {
@@ -854,20 +1167,20 @@
                 case PSN_KILLACTIVE:
                     SetWindowLongPtrW(hwndDlg, DWLP_MSGRESULT, FALSE);
                 break;
-                    
+
                 case PSN_APPLY: {
                     BtrfsPropSheet* bps = (BtrfsPropSheet*)GetWindowLongPtr(hwndDlg, GWLP_USERDATA);
-                    
+
                     bps->apply_changes(hwndDlg);
                     SetWindowLongPtrW(hwndDlg, DWLP_MSGRESULT, PSNRET_NOERROR);
                     break;
                 }
-                
+
                 case NM_CLICK:
                 case NM_RETURN: {
                     if (((LPNMHDR)lParam)->hwndFrom == GetDlgItem(hwndDlg, IDC_SIZE_ON_DISK)) {
                         PNMLINK pNMLink = (PNMLINK)lParam;
-                        
+
                         if (pNMLink->item.iLink == 0)
                             DialogBoxParamW(module, MAKEINTRESOURCEW(IDD_SIZE_DETAILS), hwndDlg, SizeDetailsDlgProc, GetWindowLongPtr(hwndDlg, GWLP_USERDATA));
                     }
@@ -875,145 +1188,40 @@
                 }
             }
         }
-        
+
         case WM_TIMER:
         {
             BtrfsPropSheet* bps = (BtrfsPropSheet*)GetWindowLongPtr(hwndDlg, GWLP_USERDATA);
-            
+
             if (bps) {
                 bps->set_size_on_disk(hwndDlg);
-                
+
                 if (!bps->thread)
                     KillTimer(hwndDlg, 1);
             }
-            
+
             break;
         }
     }
-    
+
     return FALSE;
 }
 
-static void format_size(UINT64 size, WCHAR* s, ULONG len) {
-    WCHAR nb[255], nb2[255], t[255], bytes[255];
-    WCHAR kb[255];
-    ULONG sr;
-    float f;
-    NUMBERFMTW fmt;
-    WCHAR thou[4], grouping[64], *c;
-    
-    _i64tow(size, nb, 10);
-    
-    GetLocaleInfoW(LOCALE_USER_DEFAULT, LOCALE_STHOUSAND, thou, sizeof(thou) / sizeof(WCHAR));
-    
-    fmt.NumDigits = 0;
-    fmt.LeadingZero = 1;
-    fmt.lpDecimalSep = (LPWSTR)L"."; // not used
-    fmt.lpThousandSep = thou;
-    fmt.NegativeOrder = 0;
-    
-    // Grouping code copied from dlls/shlwapi/string.c in Wine - thank you
-    
-    fmt.Grouping = 0;
-    GetLocaleInfoW(LOCALE_USER_DEFAULT, LOCALE_SGROUPING, grouping, sizeof(grouping) / sizeof(WCHAR));
-    
-    c = grouping;
-    while (*c) {
-        if (*c >= '0' && *c < '9') {
-            fmt.Grouping *= 10;
-            fmt.Grouping += *c - '0';
-        }
-        
-        c++;
-    }
-
-    if (fmt.Grouping % 10 == 0)
-        fmt.Grouping /= 10;
-    else
-        fmt.Grouping *= 10;
-    
-    GetNumberFormatW(LOCALE_USER_DEFAULT, 0, nb, &fmt, nb2, sizeof(nb2) / sizeof(WCHAR));
-    
-    if (size < 1024) {
-        if (!LoadStringW(module, size == 1 ? IDS_SIZE_BYTE : IDS_SIZE_BYTES, t, sizeof(t) / sizeof(WCHAR))) {
-            ShowError(NULL, GetLastError());
-            return;
-        }
-        
-        if (StringCchPrintfW(s, len, t, nb2) == STRSAFE_E_INSUFFICIENT_BUFFER) {
-            ShowError(NULL, ERROR_INSUFFICIENT_BUFFER);
-            return;
-        }
-        
-        return;
-    }
-    
-    if (!LoadStringW(module, IDS_SIZE_BYTES, t, sizeof(t) / sizeof(WCHAR))) {
-        ShowError(NULL, GetLastError());
-        return;
-    }
-    
-    if (StringCchPrintfW(bytes, sizeof(bytes) / sizeof(WCHAR), t, nb2) == STRSAFE_E_INSUFFICIENT_BUFFER) {
-        ShowError(NULL, ERROR_INSUFFICIENT_BUFFER);
-        return;
-    }
-    
-    if (size >= 1152921504606846976) {
-        sr = IDS_SIZE_EB;
-        f = (float)size / 1152921504606846976.0f;
-    } else if (size >= 1125899906842624) {
-        sr = IDS_SIZE_PB;
-        f = (float)size / 1125899906842624.0f;
-    } else if (size >= 1099511627776) {
-        sr = IDS_SIZE_TB;
-        f = (float)size / 1099511627776.0f;
-    } else if (size >= 1073741824) {
-        sr = IDS_SIZE_GB;
-        f = (float)size / 1073741824.0f;
-    } else if (size >= 1048576) {
-        sr = IDS_SIZE_MB;
-        f = (float)size / 1048576.0f;
-    } else {
-        sr = IDS_SIZE_KB;
-        f = (float)size / 1024.0f;
-    }
-    
-    if (!LoadStringW(module, sr, t, sizeof(t) / sizeof(WCHAR))) {
-        ShowError(NULL, GetLastError());
-        return;
-    }
-    
-    if (StringCchPrintfW(kb, sizeof(kb) / sizeof(WCHAR), t, f) == STRSAFE_E_INSUFFICIENT_BUFFER) {
-        ShowError(NULL, ERROR_INSUFFICIENT_BUFFER);
-        return;
-    }
-    
-    if (!LoadStringW(module, IDS_SIZE_LARGE, t, sizeof(t) / sizeof(WCHAR))) {
-        ShowError(NULL, GetLastError());
-        return;
-    }
-    
-    if (StringCchPrintfW(s, len, t, kb, bytes) == STRSAFE_E_INSUFFICIENT_BUFFER) {
-        ShowError(NULL, ERROR_INSUFFICIENT_BUFFER);
-        return;
-    }
-}
-
 HRESULT __stdcall BtrfsPropSheet::AddPages(LPFNADDPROPSHEETPAGE pfnAddPage, LPARAM lParam) {
     PROPSHEETPAGE psp;
     HPROPSHEETPAGE hPage;
     INITCOMMONCONTROLSEX icex;
-    
+
     if (ignore)
         return S_OK;
-    
+
     icex.dwSize = sizeof(icex);
     icex.dwICC = ICC_LINK_CLASS;
-    
+
     if (!InitCommonControlsEx(&icex)) {
         MessageBoxW(NULL, L"InitCommonControlsEx failed", L"Error", MB_ICONERROR);
     }
-    
+
     psp.dwSize = sizeof(psp);
     psp.dwFlags = PSP_USEREFPARENT | PSP_USETITLE;
     psp.hInstance = module;
@@ -1026,7 +1234,7 @@
     psp.lParam = (LPARAM)this;
 
     hPage = CreatePropertySheetPage(&psp);
-            
+
     if (hPage) {
         if (pfnAddPage(hPage, lParam)) {
             this->AddRef();
@@ -1035,7 +1243,7 @@
             DestroyPropertySheetPage(hPage);
     } else
         return E_OUTOFMEMORY;
-    
+
     return E_FAIL;
 }
 
@@ -1042,3 +1250,47 @@
 HRESULT __stdcall BtrfsPropSheet::ReplacePage(UINT uPageID, LPFNADDPROPSHEETPAGE pfnReplacePage, LPARAM lParam) {
     return S_OK;
 }
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+void CALLBACK ShowPropSheetW(HWND hwnd, HINSTANCE hinst, LPWSTR lpszCmdLine, int nCmdShow) {
+    BtrfsPropSheet* bps;
+    PROPSHEETPAGEW psp;
+    PROPSHEETHEADERW psh;
+    WCHAR title[255];
+
+    set_dpi_aware();
+
+    LoadStringW(module, IDS_STANDALONE_PROPSHEET_TITLE, title, sizeof(title) / sizeof(WCHAR));
+
+    bps = new BtrfsPropSheet;
+    bps->set_cmdline(lpszCmdLine);
+
+    psp.dwSize = sizeof(psp);
+    psp.dwFlags = PSP_USETITLE;
+    psp.hInstance = module;
+    psp.pszTemplate = MAKEINTRESOURCEW(IDD_PROP_SHEET);
+    psp.hIcon = 0;
+    psp.pszTitle = MAKEINTRESOURCEW(IDS_PROP_SHEET_TITLE);
+    psp.pfnDlgProc = (DLGPROC)PropSheetDlgProc;
+    psp.pfnCallback = NULL;
+    psp.lParam = (LPARAM)bps;
+
+    memset(&psh, 0, sizeof(PROPSHEETHEADERW));
+
+    psh.dwSize = sizeof(PROPSHEETHEADERW);
+    psh.dwFlags = PSH_PROPSHEETPAGE;
+    psh.hwndParent = hwnd;
+    psh.hInstance = psp.hInstance;
+    psh.pszCaption = title;
+    psh.nPages = 1;
+    psh.ppsp = &psp;
+
+    PropertySheetW(&psh);
+}
+
+#ifdef __cplusplus
+}
+#endif
